#ifndef	_JENCOMM_H_
#define	_JENCOMM_H_

typedef unsigned char byte;
typedef unsigned int word;
typedef unsigned long dword;

#define	NO_ERROR        0		/* everything is A OK */
#define	INVALID_COM		-1		/* valid com nos. - 1 to 5 */
#define	INVALID_BAUD	-2		/* valid baud rates - 300, 600, 1200, 2400, 4800 */
#define	TIMED_OUT		-3    /* device did not respond */
#define	DEVICE_BUSY		-4		/* device is slow to respond */
#define	UNKNOWN_PARAM	-5 	/* parameter unknown to the device */
#define	UNKNOWN_CMD		-6 	/* command unknown to the device */
#define	INVALID_DATA	-7	   /* data is invalid, out of range */
#define  RESET_ERROR    -8		/* device did not reset */
#define	BAD_USER_COM   -9    /* invalid user com port address */
#define	NO_COM         -10   /* no serial port, or malfunctioning */

/* other error distinctions are: no_device, lost_contact */
/*****************************************************************************
	THESE ARE THE FUNCTIONS THAT ARE CALLABLE IN PROTOCOL
*****************************************************************************/
void InitCom (byte ComNo, word BaudRate, int *Code);
void SetUserCom (word PortAddr, int *Code);
void SwitchToCom (byte ComNo, int *Code);
void SwitchToAddress (byte Address);
void ReadData (word ParamNo, double *Data, int *Code);
void WriteData (word ParamNo, double Data, int *Code);
void ReadFlag (word ParamNo, byte BitNo, int *Flag, int *Code);
void ReadFlags (word ParamNo, dword *Flags, int *Code);
void WriteFlag (word ParamNo, int BitNo, int Flag, int *Code);
void GetDevType (word *dev_type, int *Code);
void Invoke (int Cmd, int *Code);
#endif
