
#include <stdlib.h>
#include <conio.h>
#include <stdio.h>                      /*-------------------------*/
#include "devices.c"                    /* just include devices.c  */
													 /*-------------------------*/
char   ch;
byte   com_port;
int    errorcode,statx;
double data;

/*------------------*/
/*-- main program --*/
/*------------------*/
void locx (byte oldy,byte newy )
{
	if ( kbhit () != 0) { clrscr(); ch = getch(); exit(0); }
	gotoxy(35,oldy);
	cprintf(" ");
	gotoxy(35,newy);
	putch(0x11);
	gotoxy(18,newy);
}

main ()
{
	clrscr();
	ch = 0x0D;
	printf("Ŀ\n");
	printf("  MODEL 6230 RS232 DEMO PROGRAM  \n");
	printf("\n");
	cprintf("Input Com no.  : ");
	scanf ("\n%d",&com_port);
	InitCom(com_port,2400,&errorcode); /* baud rate fixed at 2400 */
	if (errorcode != 0)
	 { printf("Communication error! \n");
		exit(0);
	 }

	/* Available parameters for the model 6230

		102 = mV Reading
						possible positive errors
						3 = Er3 = Temp over range
						5 = Er5 = mV over range
		103 = pH Reading
						possible positive errors
						1 = Er1
						2 = Er2
						3 = Er3
						4 = Er4
						5 = Er5
		104 = Temperature reading
						possible positive error
						3 = Er3

    ***for readflag routine
       106 = readflag parameter
      allowed bit nos. for readflag =
              0 not supported
              1 not supported
				  2 not supported
				  3 not supported
                      4 =wait
                      5 =autolock
				  6 =slope
				  7 =stand
                      8 =lobat
				  9 =atc
				 10 =manual
				 11 =mV
				 12 =pH


	  read man6230.txt for explanation of errors
	  note: if the error is positive then the error came from the instrument.
			  if the error is negative then it is a communication error.
			  Check your cable and connection if the error is negative.

	  */

     gotoxy(1,5);
	  highvideo();
	  cprintf ("[ LCD DISPLAY ]");printf("\n");
	  lowvideo();
	  cprintf ("mV    DISPLAY  : ");printf("\n");
	  cprintf ("pH    DISPLAY  : ");printf("\n");
	  cprintf ("Temp. DISPLAY  : ");printf("\n");
	  highvideo();
	  cprintf ("[ ANNUNCIATORS ]");printf("\n");
	  lowvideo();
	  cprintf ("pH annunciator : ");printf("\n");
	  cprintf ("mV annunciator : ");printf("\n");
	  cprintf ("MANUAL annunc. : ");printf("\n");
	  cprintf ("ATC    annunc. : ");printf("\n");
	  cprintf ("LOBAT  annunc. : ");printf("\n");
	  cprintf ("STAND  annunc. : ");printf("\n");
	  cprintf ("SLOPE  annunc. : ");printf("\n");
	  cprintf ("AUTOLOCK       : ");printf("\n");
	  cprintf ("WAIT   annunc. : ");printf("\n");
     gotoxy(1,22);
	  cprintf ("Press any key to exit....");printf("\n");
	  highvideo();


	do
		{

		 /* read mv display */
		 locx(18,6);
		 ReadData (102,&data,&errorcode);
		 if (errorcode==0) {
							cprintf("%2.0f",data);
							cprintf("           ");
								 }
						  else {
							if (errorcode > 0) { cprintf("Er %d",errorcode);
														cprintf("          ");
													 }
							else { cprintf("Com Error %d",errorcode);
									 cprintf("      ");
								  }
								 }

		 /* read pH Display */
		 locx(6,7);
		 ReadData (103,&data,&errorcode);
		 if (errorcode==0) {
							cprintf("%2.2f",data);
							cprintf("          ");
								 }
                    else {
							if (errorcode > 0) { cprintf("Er %d",errorcode);
														cprintf("         ");
													 }
							else { cprintf("Com Error %d",errorcode);
									 cprintf("      ");
								  }
								 }

		 /* read temperture display */
		 locx(7,8);
		 ReadData (104,&data,&errorcode);
		 if (errorcode==0) {
							cprintf("%2.1f",data);
							cprintf("          ");
								 }
                    else {
							if (errorcode > 0) { cprintf("Er %d",errorcode);
														cprintf("         ");
													 }
							else { cprintf("Com Error %d",errorcode);
									 cprintf("      ");
								  }
								 }

/* *** readflags *** */

/* **** pH  */
locx (8,10);
ReadFlag(106,12,&statx,&errorcode);
if (statx == 1) cprintf("ON "); else cprintf("OFF");
/* **** mV  */
locx (10,11);
ReadFlag(106,11,&statx,&errorcode);
if (statx == 1) cprintf("ON "); else cprintf("OFF");
/* **** Manual  */
locx (11,12);
ReadFlag(106,10,&statx,&errorcode);
if (statx == 1) cprintf("ON "); else cprintf("OFF");
/* **** ATC  */
locx (12,13);
ReadFlag(106,9,&statx,&errorcode);
if (statx == 1) cprintf("ON "); else cprintf("OFF");
/* **** LOBAT  */
locx (13,14);
ReadFlag(106,8,&statx,&errorcode);
if (statx == 1) cprintf("ON "); else cprintf("OFF");
/* **** STAND  */
locx (14,15);
ReadFlag(106,7,&statx,&errorcode);
if (statx == 1) cprintf("ON "); else cprintf("OFF");
/* **** Slope  */
locx (15,16);
ReadFlag(106,6,&statx,&errorcode);
if (statx == 1) cprintf("ON "); else cprintf("OFF");
/* **** autolock  */
locx (16,17);
ReadFlag(106,5,&statx,&errorcode);
if (statx == 1) cprintf("ON "); else cprintf("OFF");
/* **** wait  */
locx (17,18);
ReadFlag(106,4,&statx,&errorcode);
if (statx == 1) cprintf("ON "); else cprintf("OFF");
}
while (1==1);
}

/*-------------------------*/
/*-- end of main program --*/
/*-------------------------*/
